//
// See the file LICENSE for redistribution information.
//
// Copyright (c) 2002-2004
//	Sleepycat Software.  All rights reserved.
//
// $Id: XmlStatistics.cpp,v 1.1 2004/09/02 16:37:42 jsnelson Exp $
//

#include "dbxml_config.h"
#include "dbxml/XmlStatistics.hpp"
#include "Statistics.hpp"

using namespace DbXml;

XmlStatistics::XmlStatistics(Statistics *statistics)
  : statistics_(statistics)
{
  statistics_->acquire();
}

XmlStatistics::~XmlStatistics()
{
	statistics_->release();
}

XmlStatistics::XmlStatistics(const XmlStatistics &o)
	: statistics_(o.statistics_)
{
	if (statistics_ != 0)
		statistics_->acquire();
}

XmlStatistics &XmlStatistics::operator=(const XmlStatistics &o)
{
	if (this != &o && statistics_ != o.statistics_) {
		if (statistics_ != 0)
			statistics_->release();
		statistics_ = o.statistics_;
		if (statistics_ != 0)
			statistics_->acquire();
	}
	return *this;
}

double XmlStatistics::getNumberOfIndexedKeys() const
{
	return statistics_->getNumberOfIndexedKeys();
}

double XmlStatistics::getNumberOfUniqueKeys() const
{
	return statistics_->getNumberOfUniqueKeys();
}

double XmlStatistics::getSumKeyValueSize() const
{
	return statistics_->getSumKeyValueSize();
}

