//
// See the file LICENSE for redistribution information.
//
// Copyright (c) 2002-2004
//	Sleepycat Software.  All rights reserved.
//
// $Id: LoadContainer.hpp,v 1.7 2004/12/12 14:17:34 gmf Exp $
//

#ifndef LOADCONTAINER_HPP
#define LOADCONTAINER_HPP

#include <string>
#include <vector>

namespace DbXml {
	class XmlManager;
}


/**
 * A class to add documents to a specified container
 *
 */
class LoadContainer {

public:
	enum StorageType {
		WHOLE_DOCUMENT,
		NODE
	};
	
	LoadContainer(const std::string &DBEnvironment, 
		      const std::string &containerName, 
		      StorageType type);
	~LoadContainer();
	
	int addFiles(const std::vector<std::string > &fileList, 
		     const std::string &pathPrepend) const;
	void addFile(const std::string &fileName) const;
	int addFileList(const std::string &pathPrepend,
			const std::string &fileName) const;

private:
 
	std::string readFile(const std::string &theFile) const;
	std::string getNameFromPath(const std::string &theFile) const;

	DbXml::XmlManager *mgr;
	std::string conName;
};
#endif
